import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

public class Main {
	public static void main(String[] args){
		//Line 31 of FindLargestConnectedComponentBioGrid.java is the last protein the matrix to fix
		//PARAMETERS testData2/InputInteractions.txt testData2/kgXref23Jan2013 testData2/5UTR_RefSeq_OneRecordPerGene28Feb13.txt 
		String folder = args[0]; //testData2
		String interactionFile = folder+"/"+args[1]; //data_nohub/BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13.txt This files still contains hubs 
		String crossReferenceTableFile = folder+"/"+args[2]; // data_nohub/kgXref23Jan2013
		String SequenceFile = folder+"/"+args[3]; // data_nohub/5UTR_RefSeq_OneRecordPerGene28Feb13.txt
		
		BuildBioGRIDDistanceMatrix DistMatrixBuilder = new BuildBioGRIDDistanceMatrix();
		String DistanceMatrixFile = DistMatrixBuilder.run(interactionFile);
		//(hubs have to be removed from the distance matrix in this file: DistanceMatrixFile)
		
		FindLargestConnectedComponentBioGrid findLargestConnectedComponentBioGrid = new FindLargestConnectedComponentBioGrid();
		String InteractionFileConnected = findLargestConnectedComponentBioGrid.run(DistanceMatrixFile, interactionFile);
		
		DistMatrixBuilder = new BuildBioGRIDDistanceMatrix();
		String DistanceMatrixConnectedFile = DistMatrixBuilder.run(InteractionFileConnected);
		
		
		
		String proteinSeqsFile ="";
		AssociateProteinsWithUTRSequences associateProteinsWithUTRSequences = new AssociateProteinsWithUTRSequences();
		proteinSeqsFile = associateProteinsWithUTRSequences.run(InteractionFileConnected, crossReferenceTableFile, SequenceFile, folder);
		
		MakeRandomDNA_UTRSequences makeRandomDNA_UTRSequences = new MakeRandomDNA_UTRSequences();
		String proteinSeqsRandomizedFile = makeRandomDNA_UTRSequences.run(proteinSeqsFile);
		
		
		GetSamplingBiasUTRSeqs getSamplingBiasUTRSeqs = new GetSamplingBiasUTRSeqs();
		String sampleBiasFile = getSamplingBiasUTRSeqs.run(proteinSeqsFile);
		
		String sampleBiasFileRand = getSamplingBiasUTRSeqs.run(proteinSeqsRandomizedFile);
		
		boolean randomized = false;
		boolean completeRandomized = false;
		
		
		  
		//Real Motif
		//========================================
		
		List<String> motifFiles = new ArrayList<String>();
		List<String> motifTooManyGenesFiles = new ArrayList<String>();
		EnumerateAllMotifOfSize8_5UTR enumerateAllMotifOfSize8_5UTR = new EnumerateAllMotifOfSize8_5UTR();
		for(int firstCharIndex = 0; firstCharIndex < 7; firstCharIndex++){
			for(int secondCharIndex = 0; secondCharIndex < 7; secondCharIndex++){
				Pair<String,String> motifFilePairs = enumerateAllMotifOfSize8_5UTR.run(firstCharIndex,secondCharIndex, randomized, completeRandomized, proteinSeqsFile);
				
				
				//These lines that are commented can be used once the motifs have been associated to each proteins.
				//String outputMotifFilePath = folder+"/"+"InputInteractions_ConnectedProteinAssociatedSequences.txt_AllMotifsFirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+".txt";
				//String outputMotifTooManyGenesFilePath = folder+"/"+"InputInteractions_ConnectedProteinAssociatedSequences.txt_MotifsTooManyGenesFirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+".txt";
				//Pair<String,String> motifFilePairs = new Pair<String,String>(outputMotifFilePath,outputMotifTooManyGenesFilePath);
				
				
				
				motifFiles.add(motifFilePairs.getf());
				motifTooManyGenesFiles.add(motifFilePairs.gets());
			}
		}
		
		System.out.println("Done generating motifs.");
		
		String concatenatedFinalString = motifFiles.get(0).split("FirstChar")[0]+motifFiles.get(0).split("SecondChar")[1].substring(1);
		String concatenatedFinalStringTooMany = motifTooManyGenesFiles.get(0).split("FirstChar")[0]+motifTooManyGenesFiles.get(0).split("SecondChar")[1].substring(1);
		String MotifAnnotationFileWithMotifsWithTooManyGenes = concatenatedFinalString;
		String MotifsWithTooManyGenes = concatenatedFinalStringTooMany;
		try{
			BufferedWriter outConcatenatedFile = new BufferedWriter(new FileWriter(new File(concatenatedFinalString)));
			for(String motifFile: motifFiles){
				BufferedReader inIndividualFile = new BufferedReader(new FileReader(new File(motifFile)));
				String line = inIndividualFile.readLine();
				while(line != null){
					outConcatenatedFile.write(line+"\n");
					outConcatenatedFile.flush();
					line = inIndividualFile.readLine();
				}
			}
			outConcatenatedFile.close();
			
			outConcatenatedFile = new BufferedWriter(new FileWriter(new File(concatenatedFinalStringTooMany)));
			for(String motifTooManyGeneFile: motifTooManyGenesFiles){
				BufferedReader inIndividualFile = new BufferedReader(new FileReader(new File(motifTooManyGeneFile)));
				String line = inIndividualFile.readLine();
				while(line != null){
					outConcatenatedFile.write(line+"\n");
					outConcatenatedFile.flush();
					line = inIndividualFile.readLine();
				}
			}
			outConcatenatedFile.close();
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		
		
		/*
		//Cat command
		String catCommandMotifs = "cat ";
		for(int i = 0; i < motifFiles.size(); i++){
			catCommandMotifs = catCommandMotifs + motifFiles.get(i) + " ";
		}
		
		
		
		catCommandMotifs = catCommandMotifs + "> " + concatenatedFinalString;
		System.out.println(concatenatedFinalString);
		System.out.println(catCommandMotifs);
		String MotifAnnotationFileWithMotifsWithTooManyGenes = concatenatedFinalString;
		//Only works for MAC and UNIX
		try {
			//Process p = Runtime.getRuntime().exec("touch testData/bla.txt");
			Process p = Runtime.getRuntime().exec("cat testData/bla.txt > testData/bla.txt");
			//Process p = Runtime.getRuntime().exec(catCommandMotifs);
            p.waitFor();
        }catch (Exception e) {
            e.printStackTrace();
        }
		
		//Cat command
		String catCommandMotifsTooMany = "cat ";
		for(int i = 0; i < motifTooManyGenesFiles.size(); i++){
			catCommandMotifsTooMany = catCommandMotifsTooMany + motifTooManyGenesFiles.get(i) + " ";
		}
		
		String concatenatedFinalStringTooMany = motifTooManyGenesFiles.get(0).split("FirstChar")[0]+motifTooManyGenesFiles.get(0).split("SecondChar")[1].substring(1);
		catCommandMotifsTooMany = catCommandMotifsTooMany + "> " + concatenatedFinalStringTooMany;
		
		System.out.println(concatenatedFinalStringTooMany);
		System.out.println(catCommandMotifsTooMany);
		
		String MotifsWithTooManyGenes = concatenatedFinalStringTooMany;
		//Only works for MAC and UNIX
		try {
            Process p = Runtime.getRuntime().exec(catCommandMotifsTooMany);
            p.waitFor();
        }catch (Exception e) {
            e.printStackTrace();
        }
		
		*/
		
		//Randomized Motif
		//========================================
				
		List<String> motifFilesRand = new ArrayList<String>();
		List<String> motifTooManyGenesFilesRand = new ArrayList<String>();
		EnumerateAllMotifOfSize8_5UTR enumerateAllMotifOfSize8_5UTRRand = new EnumerateAllMotifOfSize8_5UTR();
		for(int firstCharIndex = 0; firstCharIndex < 7; firstCharIndex++){
			for(int secondCharIndex = 0; secondCharIndex < 7; secondCharIndex++){
				Pair<String,String> motifFilePairsRand = enumerateAllMotifOfSize8_5UTRRand.run(firstCharIndex,secondCharIndex, true, completeRandomized, proteinSeqsRandomizedFile);
				
				//These lines that are commented can be used once the motifs have been associated to each proteins.
				//String outputMotifFilePath = folder+"/"+"InputInteractions_ConnectedProteinAssociatedSequences.txt_Randomized.txt_AllMotifsFirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+"Randomized.txt";
				//String outputMotifTooManyGenesFilePath = folder+"/"+"InputInteractions_ConnectedProteinAssociatedSequences.txt_Randomized.txt_MotifsTooManyGenesFirstChar"+firstCharIndex+"SecondChar"+secondCharIndex+"Randomized.txt";
				//Pair<String,String> motifFilePairsRand = new Pair<String,String>(outputMotifFilePath,outputMotifTooManyGenesFilePath);

				
				
				motifFilesRand.add(motifFilePairsRand.getf());
				motifTooManyGenesFilesRand.add(motifFilePairsRand.gets());
			}
		}
				
		
		
		String concatenatedFinalStringRand = motifFilesRand.get(0).split("FirstChar")[0]+motifFilesRand.get(0).split("SecondChar")[1].substring(1);
		String concatenatedFinalStringTooManyRand = motifTooManyGenesFilesRand.get(0).split("FirstChar")[0]+motifTooManyGenesFilesRand.get(0).split("SecondChar")[1].substring(1);
		String MotifAnnotationFileWithMotifsWithTooManyGenesRand = concatenatedFinalStringRand;
		String MotifsWithTooManyGenesRand = concatenatedFinalStringTooManyRand;
		try{
			BufferedWriter outConcatenatedFile = new BufferedWriter(new FileWriter(new File(concatenatedFinalStringRand)));
			for(String motifFileRand: motifFilesRand){
				BufferedReader inIndividualFile = new BufferedReader(new FileReader(new File(motifFileRand)));
				String line = inIndividualFile.readLine();
				while(line != null){
					outConcatenatedFile.write(line+"\n");
					outConcatenatedFile.flush();
					line = inIndividualFile.readLine();
				}
			}
			outConcatenatedFile.close();
			
			outConcatenatedFile = new BufferedWriter(new FileWriter(new File(concatenatedFinalStringTooManyRand)));
			for(String motifTooManyGeneFileRand: motifTooManyGenesFilesRand){
				BufferedReader inIndividualFile = new BufferedReader(new FileReader(new File(motifTooManyGeneFileRand)));
				String line = inIndividualFile.readLine();
				while(line != null){
					outConcatenatedFile.write(line+"\n");
					outConcatenatedFile.flush();
					line = inIndividualFile.readLine();
				}
			}
			outConcatenatedFile.close();
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		
		
		
		/*
		
		//Cat command
		String catCommandMotifsRand = "cat ";
		for(int i = 0; i < motifFilesRand.size(); i++){
			catCommandMotifsRand = catCommandMotifsRand + motifFilesRand.get(i) + " ";
		}
		
		String concatenatedFinalStringRand = motifFilesRand.get(0).split("FirstChar")[0]+motifFilesRand.get(0).split("SecondChar")[1].substring(1);
		catCommandMotifsRand = catCommandMotifsRand + "> " + concatenatedFinalStringRand;
		
		String MotifAnnotationFileWithMotifsWithTooManyGenesRand = concatenatedFinalStringRand;
		//Only works for MAC and UNIX
		try {
            Process p = Runtime.getRuntime().exec(catCommandMotifsRand);
            p.waitFor();
        }catch (Exception e) {
            e.printStackTrace();
        }
		
		//Cat command
		String catCommandMotifsTooManyRand = "cat ";
		for(int i = 0; i < motifTooManyGenesFilesRand.size(); i++){
			catCommandMotifsTooManyRand = catCommandMotifsTooManyRand + motifTooManyGenesFilesRand.get(i) + " ";
		}
		
		String concatenatedFinalStringTooManyRand = motifTooManyGenesFilesRand.get(0).split("FirstChar")[0]+motifTooManyGenesFilesRand.get(0).split("SecondChar")[1].substring(1);
		catCommandMotifsTooManyRand = catCommandMotifsTooManyRand + "> " + concatenatedFinalStringTooManyRand;
		
		String MotifsWithTooManyGenesRand = concatenatedFinalStringTooManyRand;
		//Only works for MAC and UNIX
		try {
            Process p = Runtime.getRuntime().exec(catCommandMotifsTooManyRand);
            p.waitFor();
        }catch (Exception e) {
            e.printStackTrace();
        }
		*/
		
		LeaveOutMotifWithTooManyProteins leaveOutMotifWithTooManyProteins = new LeaveOutMotifWithTooManyProteins();
		
		Pair<String,String> MotifAnnotationFilePair = leaveOutMotifWithTooManyProteins.run(MotifsWithTooManyGenesRand, MotifsWithTooManyGenesRand, MotifAnnotationFileWithMotifsWithTooManyGenes, MotifAnnotationFileWithMotifsWithTooManyGenesRand);
		String MotifAnnotationFile = MotifAnnotationFilePair.getf();
		String MotifAnnotationFileRand = MotifAnnotationFilePair.gets();
		
		
		
		DNAUTRMotifsTop1PercentGetSmallerCoresFinder DNAUTRMotifsTop1PercentGetSmallerCoresFinder = new DNAUTRMotifsTop1PercentGetSmallerCoresFinder();
		//RealAnalysis
		
		System.out.println("FILE " + DistanceMatrixConnectedFile);
		System.out.println("FILE " + InteractionFileConnected);
		
		Pair<String,String> outputFileAndCoreFile = DNAUTRMotifsTop1PercentGetSmallerCoresFinder.run(InteractionFileConnected, DistanceMatrixConnectedFile, true, 8, 5, 5, 1501, sampleBiasFile,MotifAnnotationFile, false,false /*last parameter should probably be removed*/,folder);
		
		//RandAnalysis
		DNAUTRMotifsTop1PercentGetSmallerCoresFinder.run(InteractionFileConnected, DistanceMatrixConnectedFile, true, 8, 5, 5, 1501, sampleBiasFileRand,MotifAnnotationFileRand, true,false /*last parameter should probably be removed*/,folder);
		
		
		//java MainForDNAUTRMotifsTop1PercentGetSmallerCores BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_Connected_noHub.txt BIOGRID-ORGANISM-Homo_sapiens-3.2.97.tab2_28Fev13_DistanceMatrix_Connected_noHub.txt false 8 5 5 1501 false false > NoHub8_5_106Sim_5_1501_1Percent_SmallerCoresComplete.txt &
		//completely randomized should not be used most likely was only used to prove that method was working in the paper
		
		AddSmallCoresToLESMON_Output addSmallCores = new AddSmallCoresToLESMON_Output();
		addSmallCores.run(folder,outputFileAndCoreFile.getf(), outputFileAndCoreFile.gets());
	}
}
